//***************************************************************************************
//
//  Title:  tinyFader, by One Wolf WebArt
//  Author: chris@onewolf.com (Christian Ricci)
//
//  For more information please refer to http://www.onewolf.com/
//
//  See also:  tinyFader.txt [docs]
//  
//***************************************************************************************
import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.net.*;

public class tinyFader extends Applet
    implements Runnable {		// Threaded application
 
    int spacing=12,			// Integer, spacing between lines
 	delay=50,			// Integer, controls speed of trans.
 	step=4, 			// Integer, controls step of trans.
	XPos=5, 			// Integer, XPos AKA indent
	YPos=12,			// Integer, YPos AKA vertical starting point 
        current=1,			// Flag, Data set (block of text)
	direction=1,			// Flag, Black to white or vice-versa
        color=255;                      // Color, current shade
    String[] Line = new String[24];     // String array, output to be displayed, 24 max
    Font outFont;                       // Font, output font
    boolean customFont = false;         // Flag, is there a custom font?
    Graphics offGrfx;                   // Tools for double buffering
    Image offImage;                     // Tools for double buffering
    Color background;                   // Color, resulting color******
    Thread runner;		        // Thread stuff

//***************************************************************************************
//
//  Method:   Init
//  Purpose:  To retrieve and massage parameters from HTML
//
//***************************************************************************************

    public void init() {

//****  Get Attributes                                         **************************

        String bgRed$    = getParameter("BGRED");
        String bgGreen$  = getParameter("BGGREEN");
        String bgBlue$   = getParameter("BGBLUE");
        String spacing$  = getParameter("SPACING");
        String delay$    = getParameter("DELAY");
        String XPos$     = getParameter("XPOS");
        String YPos$     = getParameter("YPOS");
        String fontName$ = getParameter("FONTNAME");
        String fontSize$ = getParameter("FONTSIZE");

//****  Get Attributes, data set 1                             **************************

        Line[0]   = getParameter("LINE1");
        Line[1]   = getParameter("LINE2");
        Line[2]   = getParameter("LINE3");
        Line[3]   = getParameter("LINE4");
        Line[4]   = getParameter("LINE5");
        Line[5]   = getParameter("LINE6");
        Line[6]   = getParameter("LINE7");
        Line[7]   = getParameter("LINE8");
        Line[8]   = getParameter("LINE9");
        Line[9]   = getParameter("LINE10");
        Line[10]  = getParameter("LINE11");
        Line[11]  = getParameter("LINE12");

//****  Get Attributes, data set 2                             **************************

        Line[12]  = getParameter("LINE13");
        Line[13]  = getParameter("LINE14");
        Line[14]  = getParameter("LINE15");
        Line[15]  = getParameter("LINE16");
        Line[16]  = getParameter("LINE17");
        Line[17]  = getParameter("LINE18");
        Line[18]  = getParameter("LINE19");
        Line[19]  = getParameter("LINE20");
        Line[20]  = getParameter("LINE21");
        Line[21]  = getParameter("LINE22");
        Line[22]  = getParameter("LINE23");
        Line[23]  = getParameter("LINE24");

//****  Massage Attributes, font                               **************************

        if ((fontSize$ != null) && (fontName$ !=null)) {
            int size = Integer.parseInt(fontSize$);
            outFont = new Font(fontName$, Font.PLAIN, size);
            customFont = true;
        }

//****  Massage Attributes, BG color                           **************************        

        int BGred = 255;
        int BGgreen = 255;
        int BGblue = 255;

        if (bgRed$ != null) BGred = Integer.parseInt(bgRed$);
        if (bgGreen$ != null) BGgreen = Integer.parseInt(bgGreen$);
        if (bgBlue$ != null) BGblue = Integer.parseInt(bgBlue$);

        background = new Color(BGred, BGgreen, BGblue);
        setBackground(background);

//****  Massage Attributes, performance/appearance stuff       **************************        

        if (spacing$ != null)
	  spacing = Integer.parseInt(spacing$);
        
        if (delay$ != null)
	  delay = Integer.parseInt(delay$);
       
        if (XPos$ != null)
	  XPos = Integer.parseInt(XPos$);
       
        if (YPos$ != null)
	  YPos = Integer.parseInt(YPos$);

//****  Prep buffer                                            **************************               
 
        offImage = createImage(size().width, size().height);
        offGrfx = offImage.getGraphics();

    }

//***************************************************************************************
//
//  Method:   Paint
//  Purpose:  Put the stuff on the screen -- you could easily condense this method if
//            you're only using two blocks of text.  I parsed this version of the applet
//            from a more custom one with some fancier text manipulation...  
//
//***************************************************************************************

    public void paint(Graphics screen) {
	Color nColor = new Color(color, color, color);
        if (current==1)
	{
                offGrfx.setColor(background);
                offGrfx.fillRect(0, 0, size().width, size().height);
                offGrfx.setColor(nColor);
                try { offGrfx.setFont(outFont); }
                catch (NullPointerException e) {}
        	for (int i=0; i<12; i++) 
            	offGrfx.drawString(Line[i],  XPos, YPos + (i * spacing));
                screen.drawImage(offImage, 0, 0, this);
        }
        else 
  	{
                offGrfx.setColor(background);
                offGrfx.fillRect(0, 0, size().width, size().height);
                offGrfx.setColor(nColor);
                try { offGrfx.setFont(outFont); }
                catch (NullPointerException e) {}
        	for (int i=12; i<24; i++) 
            	offGrfx.drawString(Line[i],  XPos, YPos + ((i-12) * spacing));
                screen.drawImage(offImage, 0, 0, this);
      	} 
    }

//***************************************************************************************
//
//  Method:   Update
//  Purpose:  Override standard version of method
//
//***************************************************************************************

    public void update(Graphics screen) {
        paint(screen);
    } 

//***************************************************************************************
//
//  Methods:  Start, run and stop
//  Purpose:  Thread methods.  Modify run in conjunction with paint to control 
//            text/content manipulation.
//
//***************************************************************************************

    public void start() {
        if (runner == null) {
            runner = new Thread(this);
            runner.start();
        }
    }

    public void run() {
        while (true) {
            repaint();
	    if (direction == 1)
		{
		color--;
		if (color < 0)
		  {
		  color = 0; 
		  direction = 0; 
		  }
		}
 	    else
		{
		color++;
		if (color > 255)
		  {
		  color = 255;
		  direction = 1;
                  current = current * -1;
		  }
		}
            try { Thread.sleep(delay); }
            catch (InterruptedException e) { }
        }
    }

    public void stop() {
        if (runner != null) {
            runner.stop();
            runner = null;
        }
    }
}
